package com.example.demo;

import java.util.HashMap;
import java.util.Map;

import com.example.demo.model.Person;
import com.thoughtworks.xstream.security.ExplicitTypePermission;

import org.springframework.batch.item.ExecutionContext;
import org.springframework.batch.item.xml.StaxEventItemReader;
import org.springframework.core.io.ClassPathResource;
import org.springframework.oxm.xstream.XStreamMarshaller;

public class DemoApplication {

    public static void main(String[] args) throws Exception {
        Map<String, Class<?>> aliasesByType = new HashMap<>();
        aliasesByType.put("person", Person.class);
        Class<?>[] allowedTypes = {Person.class};
        ExplicitTypePermission explicitTypePermission = new ExplicitTypePermission(allowedTypes);

        XStreamMarshaller marshaller = new XStreamMarshaller();
        marshaller.setAliasesByType(aliasesByType);
        marshaller.setTypePermissions(explicitTypePermission);

        StaxEventItemReader<Person> reader = new StaxEventItemReader<>();
        reader.setUnmarshaller(marshaller);
        reader.setFragmentRootElementName("person");
        reader.setResource(new ClassPathResource("persons.xml"));

        reader.open(new ExecutionContext());
        Person person = reader.read();
        System.out.println("person1 = " + person);
        person = reader.read();
        System.out.println("person2 = " + person);
        reader.close();
    }

}
